#ifndef BASE64_H
#define BASE64_H

#include <stdlib.h>

#define BASE64_ENCODE_MAX_LEN(X) (((X) + 2) / 3 * 4 + 1)
#define BASE64_DECODE_MAX_LEN(X) (((X) >> 2) * 3)

// Base64 encode return 0 if failed.
int encode_base64(
    char *const encoded_data, const unsigned char *data, 
    size_t input_length);

// Base64 decode return 0 if failed.
int decode_base64(
    unsigned char *const decoded_data, const char *data, 
    size_t input_length, size_t output_max_length, size_t *output_length);

#endif