#ifndef PQSIGN_H
#define PQSIGN_H

#include <stdint.h>
#include "../pqmagic/aigis/std/api.h"

#define PQSIGN_VERSION "0.1"

#define ALG_NAME_MAX_SIZE 12
#define ALG_NAME "Aigis-sig"

#define DEFAULT_PUBKEY_FILE "pqsign.pub"
#define DEFAULT_SECKEY_FILE "pqsign.key"
#define DEFAULT_SIG_EXT ".pqsig"

typedef struct PubKey {
    uint8_t alg_name[ALG_NAME_MAX_SIZE];
    uint8_t pk[SIG_PUBLICKEYBYTES];
} PubKey;

typedef struct SecKey {
    uint8_t alg_name[ALG_NAME_MAX_SIZE];
    uint8_t sk[SIG_SECRETKEYBYTES];
} SecKey;

typedef struct Sig
{
    uint8_t alg_name[ALG_NAME_MAX_SIZE];
    uint8_t sig[SIG_BYTES];
    size_t sig_len;
} Sig;

#endif