#ifndef UTILS_H
#define UTILS_H

#include <stdlib.h>

#define PQSIGN_FILE_OPEN_ERROR -1
#define PQSIGN_FILE_MMAP_ERROR -2
#define PQSIGN_FILE_MUNMAP_ERROR -3
#define PQSIGN_FILE_FSTAT_ERROR -4
#define PQSIGN_FILE_SIZE_ERROR -5

// return 1 if file exists, otherwise return 0.
int file_exists(const char *filename);

size_t get_file_size(const char *filename);
size_t get_file_size_with_fd(int fd);

void exit_with_error_msg(const char* msg);
void exit_with_perror_msg(const char* msg);

// return ERROR CODE (neg num) if failed, return 1 if succeed. 
int write_file(const char *filename, char *write_content, size_t size);

// return ERROR CODE (neg num) if failed, return read_size if succeed.
int read_file(const char *filename, char *read_content, size_t max_size);

#endif